Subject: [YANG] module version field

From: Andy Bierman <[email-masked]>
Date: Fri, 08 Feb 2008 15:10:59 -0800

Hi,

The [sub]module version field is kind of important, and there is none in YANG.
SMIv2 has LAST-UPDATED. I like 'version'.  It is CLI and XSD friendly.

IMO, the version string should not be coupled to the LAST-UPDATED timestamp.
What if the vendor has a totally different numbering scheme?

An explicit version field could be a CLR -- just something to match up
to some other string somewhere else, or it could be extra semantics.
The current syntax only allows 1 version per day, which is not good enough
in every development environment.

I think we should consider adding an optional version field to meta-stmts.
If missing, then the most recent revision date is used,
and if no revision statements are present, then the vendor
can use whatever they want (including no version).

Whatever we use, there needs to be exactly one inter-operable field
that can be used in schema discovery, that matches a version
field in YANG/XSD/RNG files.  The namespace URI should not be used for
this purpose.  For protocol features, like the capability URIs,
a version field in the URI is OK because it doesn't change very often,
and NETCONF supports extensions.  YANG module versions should be separate
from the module namespace URI.

Once we work on change control rules, the important CLRs
will get defined ;-)

Andy

_______________________________________________
YANG mailing list
[email-masked]
http://www.ietf.org/mailman/listinfo/yang